--- C:\Home\Roundup-Modifications\client.py.rel0.8.5	Tue Jan 03 14:58:56 2006
+++ C:\Home\Roundup-Modifications\client.py.sf	Tue Jan 03 17:46:27 2006
@@ -399,11 +399,13 @@
         # by a front-end HTTP server)
         use_http_auth = self.instance.config['WEB_HTTP_AUTH'] == 'yes'
         user = 'anonymous'
-        if use_http_auth:
-            if self.env.has_key('REMOTE_USER'):
-                user = self.env['REMOTE_USER']
-            # try handling Basic Auth ourselves
-            elif self.env.get('HTTP_AUTHORIZATION', ''):
+
+        # we have external auth (e.g. by Apache) and want to use that
+        if self.env.has_key('REMOTE_USER') and use_http_auth:
+            user = self.env['REMOTE_USER']
+
+        # try handling Basic Auth ourselves
+        elif self.env.get('HTTP_AUTHORIZATION', '') and use_http_auth:
                 auth = self.env['HTTP_AUTHORIZATION']
                 scheme, challenge = auth.split(' ', 1)
                 if scheme.lower() == 'basic':
@@ -423,21 +425,23 @@
 
                     user = username
 
-        # look up the user session cookie (may override the HTTP Basic Auth)
-        cookie = self.cookie
-        if (cookie.has_key(self.cookie_name) and
-                cookie[self.cookie_name].value != 'deleted'):
+        # try to identify user by ccokie
+        else:
+            # look up the user session cookie
+            cookie = self.cookie
+            if (cookie.has_key(self.cookie_name) and
+                    cookie[self.cookie_name].value != 'deleted'):
 
-            # get the session key from the cookie
-            self.session = cookie[self.cookie_name].value
-            # get the user from the session
-            try:
-                # update the lifetime datestamp
-                sessions.updateTimestamp(self.session)
-                user = sessions.get(self.session, 'user')
-            except KeyError:
-                # not valid, ignore id
-                pass
+                # get the session key from the cookie
+                self.session = cookie[self.cookie_name].value
+                # get the user from the session
+                try:
+                    # update the lifetime datestamp
+                    sessions.updateTimestamp(self.session)
+                    user = sessions.get(self.session, 'user')
+                except KeyError:
+                    # not valid, ignore id
+                    pass
 
         # sanity check on the user still being valid, getting the userid
         # at the same time

 	  	 
